#define GEISTER_C

#include "geister.h"
#include "geisterclient.h"

#include<stdlib.h>
#include<stdio.h>
#include<math.h>
#include<string.h>

//int player_cur;
//int player_opp;

int board_score[BDW][BDH] = {{5,3,1,1,3,5},
			     {3,1,0,0,1,3},
			     {1,0,0,0,0,1},
			     {1,0,0,0,0,1},
			     {3,1,0,0,1,3},
			     {5,3,1,1,3,5}};
int sub_goal[BDW][BDH] = {{32,16,8,3,2,1},
			  {0,0,0,2,1,0},
			  {0,0,0,0,0,0},
			  {0,0,0,0,0,0},
			  {0,0,0,0,0,0},
			  {0,0,0,0,0,0}};
int sub_goal_opp[BDW][BDH] = {{-10,-10,-10,0,-20,-40},
			      {-10,-10,0,-10,-20},
			      {-10,0,0,0,0,0},
			      {0,0,0,0,0,0},
			      {0,0,0,0,-10,-20},
			      {0,0,0,0,-20,-40}};
int blue_atack[BDW][BDH] = {{6,5,4,3,2,1},
			    {6,5,4,3,2,1},
			    {6,5,4,3,2,1},
			    {6,5,4,3,2,1},
			    {6,5,4,3,2,1},
			    {6,5,4,3,2,1}};
int blue_gard[BDW][BDH] = {{1,2,3,4,5,6},
			   {1,2,3,4,5,6},
			   {1,2,3,4,5,6},
			   {1,2,3,4,5,6},
			   {1,2,3,4,5,6},
			   {1,2,3,4,5,6}};
int blue_keeper[BDW][BDH] = {{0,0,0,0,0,0},
			     {0,0,0,0,0,10},
			     {0,0,0,0,0,0},
			     {0,0,0,0,0,0},
			     {0,0,0,0,0,10},
			     {0,0,0,0,0,0}};
float estimate_blue[BDW][BDH] = {{1.1,1.2,1.4,1.4,2.5,3.5},
				 {1.1,1.1,1.1,1.1,1.5,1.2},
				 {0.1,0.1,0.1,0.1,1.1,1.4},
				 {0.1,0.1,0.1,0.1,1.1,1.4},
				 {1.1,1.1,1.1,1.1,1.5,2.5},
				 {1.1,1.2,1.4,1.4,2.5,3.5}};
float estimate_blue_first[BDW][BDH] = {{1.4,1.2,1.1,0.5,0.8,1.2},
				       {1.5,1.1,1.1,0.1,0.8,1.1},
				       {1.1,0.5,0.1,0.1,0.5,0.1},
				       {1.1,0.5,0.1,0.1,0.5,0.1},
				       {1.5,1.1,1.1,0.1,0.8,1.1},
				       {1.4,1.2,1.1,0.5,0.8,1.2}};

float estimate_before[BDW][BDH]={};

int direction[2][4] = {{0,1,0,-1},{-1,0,1,0}};
int anti_dir[4] = { SOUTH, WEST, NORTH, EAST};

void print_board(struct STATE *s, int player_cur);
void print_state(struct STATE s);
void board_init(struct STATE *s);
void apply_action(struct STATE *s, struct  ACTION a, int player_cur);
int judge(struct STATE *s, struct ACTION a, int player_cur);
int check(struct STATE *s, struct ACTION a, int player_cur);
int reward(struct STATE *s, struct ACTION a, int player_cur);
void hum_play(struct STATE *s, int player_cur);
int com_play(struct STATE *s, int player_cur, int depth, struct ACTION *a);
void strategy_grid_re(struct STATE *s, struct ACTION *a, int player_cur);
void strategy_escape(struct STATE *s, struct ACTION *a, int player_cur);
void strategy_random(struct STATE *s, struct ACTION *a, int player_cur);
void strategy_blue_back(struct STATE *s, struct ACTION *a, int player_cur);
void estimation(struct STATE *s, int player_cur, struct STATE *estimate);
void estimation_init();
void estimation_update(struct STATE *estimate);
int make_weight(int weight, int x);
void strategy_red_foward(struct STATE *s, struct ACTION *a, int player_cur);

void print_board(struct STATE *s, int player_cur){
  int i, j;
  
  printf("  ");
  for( i=0; i<BDW; i++){
    printf("| %d ",i);
  }
  printf("|\n");
  printf("__");
  for( i=0; i<BDW; i++){
    printf("|___");
  }
  printf("|\n");

  for( j=0; j<BDH; j++){
    printf("%d ",j);
    for( i=0; i<BDW; i++){
	if(player_cur == PLAYER0){
	  switch(s->board[i][j]){
	  case 0: printf("| r ");//player0_red
	    break;
	  case 1: printf("| b ");//player0_blue
	    break;
	  case EMPTY: printf("|   ");
	    break;
	  default: printf("| o ");
	    break;
	  } 
	}
	else{
	  switch(s->board[i][j]){
	  case 2: printf("| R ");//player1_red
	    break;
	  case 3: printf("| B ");//player1_blue
	    break;
          case EMPTY: printf("|   ");
	    break;
	  default: printf("| o ");
	    break;
	  }
	}
    }
    printf("|\n");
    printf("__");
    for( i=0; i<BDW; i++){
      printf("|___");
    }
    printf("|\n");
  }
  printf("\n");
  return ;

}

void print_state(struct STATE s){
  int i, j;
  
  printf("  ");
  for( i=0; i<BDW; i++){
    printf("| %d ",i);
  }
  printf("|\n");
  printf("__");
  for( i=0; i<BDW; i++){
    printf("|___");
  }
  printf("|\n");

  for( j=0; j<BDH; j++){
    printf("%d ",j);
    for( i=0; i<BDW; i++){
	  switch(s.board[i][j]){
	  case 0: printf("| r ");//player0_red
	    break;
	  case 1: printf("| b ");//player0_blue
	    break;
	  case 2: printf("| R ");//player1_red
	    break;
	  case 3: printf("| B ");//player1_blue
	    break;
          case EMPTY: printf("|   ");
	    break;
	  default: printf("| o ");
	    break;
	  }
    }

    printf("|\n");
    printf("__");

    for( i=0; i<BDW; i++){
      printf("|___");
    }
    printf("|\n");
  }
    printf("\n");
  return ;

}

void board_init(struct STATE *s){
  int i, j;

  for( j=0; j<BDH; j++){
    for( i=0; i<BDW; i++){
      s->board[i][j] = EMPTY;
    }
  }
  for( j=0; j<2; j++){
    for( i=0; i<2; i++){
      s->ghost_num[i][j] = 0;
    }
  }

  for (j=0;j<2;j++){
    for (i=0;i<8;i++) {
      s->ghost[j][i].x=9;
      s->ghost[j][i].y=9;
      s->ghost[j][i].c=UNKNOWN;
    }
  }

  return;

}

void ghost_set_com(struct STATE *s, int player_com){
  int x;
  int i,j;
  int red, blue;
  
  red =  player_com*2+RED*1;
  blue =  player_com*2+BLUE*1;
 
  for(x=1;x<4;x++){
    s->board[x][0] = UNKNOWN;
    s->board[x][1] = UNKNOWN;
    s->board[x][4] = UNKNOWN;
    s->board[x][5] = UNKNOWN;
  }

  if(player_com == PLAYER0){
    s->board[1][4] = red;
    s->board[2][4] = red;
    s->board[3][4] = red;
    s->board[4][4] = blue;
    s->board[1][5] = blue;
    s->board[2][5] = blue;
    s->board[3][5] = blue;
    s->board[4][5] = red;
    s->ghost[0][0].x=1;s->ghost[0][0].y=4;s->ghost[0][0].c=RED;
    s->ghost[0][1].x=2;s->ghost[0][0].y=4;s->ghost[0][0].c=RED;
    s->ghost[0][2].x=3;s->ghost[0][0].y=4;s->ghost[0][0].c=RED;
    s->ghost[0][3].x=4;s->ghost[0][0].y=4;s->ghost[0][0].c=BLUE;
    s->ghost[0][4].x=1;s->ghost[0][0].y=5;s->ghost[0][0].c=BLUE;
    s->ghost[0][5].x=2;s->ghost[0][0].y=5;s->ghost[0][0].c=BLUE;
    s->ghost[0][6].x=3;s->ghost[0][0].y=5;s->ghost[0][0].c=BLUE;
    s->ghost[0][7].x=4;s->ghost[0][0].y=5;s->ghost[0][0].c=RED;
    s->ghost[1][0].x=4;s->ghost[0][0].y=1;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][1].x=3;s->ghost[0][0].y=1;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][2].x=2;s->ghost[0][0].y=1;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][3].x=1;s->ghost[0][0].y=1;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][4].x=4;s->ghost[0][0].y=0;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][5].x=3;s->ghost[0][0].y=0;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][6].x=2;s->ghost[0][0].y=0;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][7].x=1;s->ghost[0][0].y=0;s->ghost[0][0].c=UNKNOWN;
  } else if(player_com == PLAYER1){
    s->board[4][1] = red;
    s->board[3][1] = red;
    s->board[2][1] = red;
    s->board[1][1] = blue;
    s->board[4][0] = blue;
    s->board[3][0] = blue;
    s->board[2][0] = blue;
    s->board[1][0] = red;
    s->ghost[0][0].x=4;s->ghost[0][0].y=1;s->ghost[0][0].c=RED;
    s->ghost[0][1].x=3;s->ghost[0][0].y=1;s->ghost[0][0].c=RED;
    s->ghost[0][2].x=2;s->ghost[0][0].y=1;s->ghost[0][0].c=RED;
    s->ghost[0][3].x=1;s->ghost[0][0].y=1;s->ghost[0][0].c=BLUE;
    s->ghost[0][4].x=4;s->ghost[0][0].y=0;s->ghost[0][0].c=BLUE;
    s->ghost[0][5].x=3;s->ghost[0][0].y=0;s->ghost[0][0].c=BLUE;
    s->ghost[0][6].x=2;s->ghost[0][0].y=0;s->ghost[0][0].c=BLUE;
    s->ghost[0][7].x=1;s->ghost[0][0].y=0;s->ghost[0][0].c=RED;
    s->ghost[1][0].x=1;s->ghost[0][0].y=4;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][1].x=2;s->ghost[0][0].y=4;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][2].x=3;s->ghost[0][0].y=4;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][3].x=4;s->ghost[0][0].y=4;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][4].x=1;s->ghost[0][0].y=5;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][5].x=2;s->ghost[0][0].y=5;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][6].x=3;s->ghost[0][0].y=5;s->ghost[0][0].c=UNKNOWN;
    s->ghost[1][7].x=4;s->ghost[0][0].y=5;s->ghost[0][0].c=UNKNOWN;
  }

  s->ghost_num[0][0] = 4;
  s->ghost_num[0][1] = 4;
  s->ghost_num[1][0] = 4;
  s->ghost_num[1][1] = 4;

  return;
}

int check(struct STATE *s, struct ACTION a, int player_cur){
  int red_cur, blue_cur;
  
  red_cur = player_cur*2+RED*1;
  blue_cur = player_cur*2+BLUE*1;

  if(0>a.x) return FALSE;
  if(a.x>BDW-1) return FALSE;
  if(0>a.y) return FALSE;
  if(a.y>BDH-1) return FALSE;
  if(0>a.dir) return FALSE;
  if(a.dir>3) return FALSE;
  if(s->board[a.x][a.y] != red_cur){
    if(s->board[a.x][a.y] != blue_cur) return FALSE;
  }
  switch(a.dir){
  case NORTH:
    if(a.y-1<0){
      if(player_cur == PLAYER1) return FALSE;
      if(s->board[a.x][a.y] == red_cur) return FALSE;
      if(a.x<BDW-1){
	if(0<a.x)return FALSE;
      }
      if((a.x == 0)||(a.x == BDW-1)) return TRUE;
    }
    if((s->board[a.x][a.y-1] == red_cur)||(s->board[a.x][a.y-1] == blue_cur))return FALSE;
    else return TRUE;
  case EAST:
    if(a.x+1>BDW-1){
      if(s->board[a.x][a.y] == red_cur) return FALSE;
      if((player_cur == PLAYER0)&&(a.y == 0)) return TRUE;
      if((player_cur == PLAYER1)&&(a.y == BDH-1)) return TRUE;
      return FALSE;
    }
    if((s->board[a.x+1][a.y] == red_cur)||(s->board[a.x+1][a.y] == blue_cur))return FALSE;
    else return TRUE;
  case SOUTH:
    if(a.y+1>BDH-1){
      if(player_cur == PLAYER0) return FALSE;
      if(s->board[a.x][a.y] == red_cur) return FALSE;
      if(a.x<BDW-1){
	if(0<a.x)return FALSE;
      }
      if((a.x == 0)||(a.x == BDW-1)) return TRUE;
    }
    if((s->board[a.x][a.y+1] == red_cur)||(s->board[a.x][a.y+1] == blue_cur))return FALSE;
    else return TRUE;
  case WEST:
    if(a.x-1<0){
      if(s->board[a.x][a.y] == red_cur) return FALSE;
      if((player_cur == PLAYER0)&&(a.y == 0)) return TRUE;
      if((player_cur == PLAYER1)&&(a.y == BDH-1)) return TRUE;
      return FALSE;
    }
    if((s->board[a.x-1][a.y] == red_cur)||(s->board[a.x-1][a.y] == blue_cur))return FALSE;
    else return TRUE;
  default: return FALSE;
  }
  return TRUE;
}

void apply_action(struct STATE *s, struct ACTION a, int player_cur){
  int temp;

  temp = s->board[a.x][a.y];
  s->board[a.x][a.y] = EMPTY;
  if(0 > a.x+direction[DIR_X][a.dir]) return;
  if(a.x+direction[DIR_X][a.dir] > BDW-1) return;
  if(0 > a.y+direction[DIR_Y][a.dir]) return;
  if(a.y+direction[DIR_Y][a.dir] > BDH-1) return;
  s->board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]] = temp;

  return;

}

void estimation(struct STATE *s,int player_cur,struct STATE *estimate){
  int player_opp = 1-player_cur;
  int red_opp = player_opp*2+RED*1;
  int blue_opp = player_opp*2+BLUE*1;
  int red_cur = player_cur*2+RED*1;
  int blue_cur = player_cur*2+BLUE*1;
  int temp_board[BDW][BDH];
  float temp_estimate_blue[BDW][BDH];
  float temp_estimate_blue_first[BDW][BDH];
  float temp_estimate;
  int temp_ghost_num[2][2];
  float threshold = 0,bayes = s->ghost_num[player_opp][BLUE];
  int dice;
  float alpha;
  int ghost_opp_num = s->ghost_num[player_opp][RED] + s->ghost_num[player_opp][BLUE];
  int i,j,k = 0, mc = 0, l = 0;
  float before[BDW][BDH]={};
  float before_score_blue = 1.2;
  float before_score_red = 0.8;
  int ghost_rank[8][5];

  for(i=0;i<8;i++){
    ghost_rank[i][LOC_X] = 9;
    ghost_rank[i][LOC_Y] = 9;
    ghost_rank[i][COLOR] = UNKNOWN;
    ghost_rank[i][BLUE_VALUE] = -20;
    ghost_rank[i][RANK] = ghost_opp_num;
  }
  for(i=0;i<BDW;i++){
    for(j=0;j<BDH;j++){

      if(s->board[i][j] == blue_cur)temp_board[i][j] = s->board[i][j];
      else if(s->board[i][j] == red_cur)temp_board[i][j] = s->board[i][j];
      else if(s->board[i][j] == EMPTY)temp_board[i][j] = s->board[i][j];
      else{
	temp_board[i][j] = UNKNOWN;
	ghost_rank[k][LOC_X] = i;
	ghost_rank[k][LOC_Y] = j;
	k++;
      }
    
      if(estimate_before[i][j] == blue_opp)before[i][j] = before_score_blue;
      else if(estimate_before[i][j] == red_opp)before[i][j] = before_score_red;
      else before[i][j] = 1.0;
      
      temp_estimate_blue[i][j] = estimate_blue[i][j];
    }
  }
  
  for(j=0;j<BDH;j++){
    for(i=0;i<BDW;i++){
      if(temp_board[i][j] == UNKNOWN){
	if(estimate_before[i][j] == EMPTY){
	  if((estimate_before[i+1][j] == red_opp)&&(temp_board[i+1][j] != UNKNOWN)) before[i][j] = before_score_red;
	  if((estimate_before[i][j+1] == red_opp)&&(temp_board[i][j+1] != UNKNOWN)) before[i][j] = before_score_red;
	  if((estimate_before[i-1][j] == red_opp)&&(temp_board[i-1][j] != UNKNOWN)) before[i][j] = before_score_red;
	  if((estimate_before[i][j-1] == red_opp)&&(temp_board[i][j-1] != UNKNOWN)) before[i][j] = before_score_red;
	  if((estimate_before[i+1][j] == blue_opp)&&(temp_board[i+1][j] != UNKNOWN)) before[i][j] = before_score_blue;
	  if((estimate_before[i][j+1] == blue_opp)&&(temp_board[i][j+1] != UNKNOWN)) before[i][j] = before_score_blue;
	  if((estimate_before[i-1][j] == blue_opp)&&(temp_board[i-1][j] != UNKNOWN)) before[i][j] = before_score_blue;
	  if((estimate_before[i][j-1] == blue_opp)&&(temp_board[i][j-1] != UNKNOWN)) before[i][j] = before_score_blue;
	}
      }
    }
  }
  
  for(i=0;i<2;i++){
    for(j=0;j<2;j++){
      estimate->ghost_num[i][j] = s->ghost_num[i][j];
      temp_ghost_num[i][j] = s->ghost_num[i][j];
    }
  }
  if(player_cur == PLAYER1){
    for(i=0;i<BDW;i++){
      for(j=0;j<BDH/2;j++){
	temp_estimate = temp_estimate_blue[i][j];
	temp_estimate_blue[i][j] = temp_estimate_blue[i][BDH-1-j];
	temp_estimate_blue[i][BDH-1-j] = temp_estimate;
      }
    }
  }

  for(j=0;j<BDH;j++){
    for(i=0;i<BDW;i++){
      if(temp_board[i][j] != UNKNOWN){
	estimate->board[i][j] = temp_board[i][j];
	continue;
      }
      alpha = (float)temp_ghost_num[player_opp][BLUE]/(float)ghost_opp_num;

      bayes = -logf(1 - alpha)*temp_estimate_blue[i][j]*before[i][j];

      threshold += ghost_opp_num*(1 - expf(-bayes));
      for(l=0;l<10;l++){
	dice = rand()%ghost_opp_num + 1;	
	if(dice <= threshold) mc++;
	else mc--;
      }
      for(k=0;k<8;k++){
	if((ghost_rank[k][LOC_X] == i)&&(ghost_rank[k][LOC_Y] == j))ghost_rank[k][BLUE_VALUE] = mc;
      }
      mc = 0;
      threshold = 0;
    }
  }
  int rank = 0;
  for(k=0;k<ghost_opp_num;k++){
    for(l=0;l<ghost_opp_num;l++){
      if(ghost_rank[l][BLUE_VALUE]<=ghost_rank[k][BLUE_VALUE]) rank++;
    }
    ghost_rank[k][RANK] = ghost_opp_num - rank + 1;
    rank = 0;
  }
  l=0;
  for(k=0;k<ghost_opp_num;k++){
    if(ghost_rank[k][RANK]<=temp_ghost_num[player_opp][BLUE]){
      estimate->board[ghost_rank[k][LOC_X]][ghost_rank[k][LOC_Y]] = blue_opp;
      ghost_rank[k][COLOR] = BLUE;
      l++;
    }
    if(l >= temp_ghost_num[player_opp][BLUE]) break;
  }
  for(k=0;k<ghost_opp_num;k++){
    if(ghost_rank[k][COLOR] == UNKNOWN) estimate->board[ghost_rank[k][LOC_X]][ghost_rank[k][LOC_Y]] = red_opp;
  }
  return;
}

void estimation_init(){
  int x,y;
  for (y=0;y<BDW;y++)
    for (x=0;x<BDH;x++)
      estimate_before[x][y] = 0;
}

void estimation_update(struct STATE *estimate){
  int x,y;
  for (y=0;y<BDW;y++)
    for (x=0;x<BDH;x++)
      estimate_before[x][y] = estimate->board[x][y];
}


int make_weight(int weight,int x){
  int i, core=1;
  for(i=0;i<x;i++){
    core = core*weight;
  }
  return core;
}

int reward(struct STATE *s, struct ACTION a, int player_cur){
  int reward;
  int next_reward, cur_reward;
  int red_opp, blue_opp, red_cur, blue_cur;
  int player_opp = 1 - player_cur;
  int i, j, r;
  int ghost_opp_num;
  struct STATE temp;
  int temp_sub;
  int temp_sub_goal[BDW][BDH];
  int temp_sub_goal_opp[BDW][BDH];
  int temp_blue_atack[BDW][BDH], temp_blue_gard[BDW][BDH], temp_blue_keeper[BDW][BDH];

  for(i=0;i<BDW;i++){
    for(j=0;j<BDH;j++){
      temp.board[i][j] = s->board[i][j];
      temp_sub_goal[i][j] = sub_goal[i][j];
      temp_sub_goal_opp[i][j] = sub_goal_opp[i][j];
      temp_blue_atack[i][j] = blue_atack[i][j];
      temp_blue_gard[i][j] = blue_gard[i][j];
      temp_blue_keeper[i][j] = blue_keeper[i][j];      
    }
  }
  if(player_cur == PLAYER1){
    for(i=0;i<BDW;i++){
      for(j=0;j<BDW/2;j++){
	temp_sub = temp_sub_goal[i][j];
	temp_sub_goal[i][j] = temp_sub_goal[i][BDH-1-j];
	temp_sub_goal[i][BDH-1-j] = temp_sub;
	temp_sub = temp_sub_goal_opp[i][j];
	temp_sub_goal_opp[i][j] = temp_sub_goal_opp[i][BDH-1-j];
	temp_sub_goal_opp[i][BDH-1-j] = temp_sub;
	temp_sub = temp_blue_atack[i][j];
	temp_blue_atack[i][j] = temp_blue_atack[i][BDH-1-j];
	temp_blue_atack[i][BDH-1-j] = temp_sub;
	temp_sub = temp_blue_gard[i][j];
	temp_blue_gard[i][j] = temp_blue_gard[i][BDH-1-j];
	temp_blue_gard[i][BDH-1-j] = temp_sub;
	temp_sub = temp_blue_keeper[i][j];
	temp_blue_keeper[i][j] = temp_blue_keeper[i][BDH-1-j];
	temp_blue_keeper[i][BDH-1-j] = temp_sub;
      }
    }
  }
  for(i=0;i<2;i++){
    for(j=0;j<2;j++){
      temp.ghost_num[i][j] = s->ghost_num[i][j];
    }
  }

  red_opp = player_opp*2+RED*1;
  blue_opp = player_opp*2+BLUE*1;
  red_cur = player_cur*2+RED*1;
  blue_cur = player_cur*2+BLUE*1;
  ghost_opp_num = temp.ghost_num[player_opp][RED] + temp.ghost_num[player_opp][BLUE];  
  
  if(temp.board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]] != EMPTY){
    if(temp.board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]] == red_opp) temp.ghost_num[player_opp][RED]--;
    else temp.ghost_num[player_opp][BLUE]--;
  }
  
  int weight_red = make_weight(2,temp.ghost_num[player_cur][RED]);
  int weight_blue = make_weight(2,4-temp.ghost_num[player_cur][BLUE]);
  int weight_red_opp = make_weight(2,4-temp.ghost_num[player_opp][RED]);
  int weight_blue_opp = make_weight(2,temp.ghost_num[player_opp][BLUE]);
  int weight_score = 1;
  int weight_sub = 1;
  int weight_sub_opp = 1;
  int weight_blue_atack = temp.ghost_num[player_opp][BLUE];
  int weight_blue_gard = 4-temp.ghost_num[player_cur][BLUE];
  int weight_blue_keeper = 1;

  reward = weight_blue*temp.ghost_num[player_cur][BLUE] - weight_red*temp.ghost_num[player_cur][RED] + weight_red_opp*temp.ghost_num[player_opp][RED] - weight_blue_opp*temp.ghost_num[player_opp][BLUE];
  apply_action( &temp, a, player_cur);

  for(i=0;i<BDW;i++){
    for(j=0;j<BDH;j++){
      if((temp.board[i][j] == red_cur)||(temp.board[i][j] == blue_cur))reward += weight_score*board_score[i][j];
      if((temp.board[i][j] == blue_cur)){
	reward += weight_sub*temp_sub_goal[i][j];
	reward += weight_blue_atack*temp_blue_atack[i][j];
	reward += weight_blue_gard*temp_blue_gard[i][j];
	reward += weight_blue_keeper*temp_blue_keeper[i][j];
      }
      if((temp.board[i][j] == red_opp)||(temp.board[i][j] == blue_opp))reward += weight_sub_opp*temp_sub_goal_opp[i][j];
    }
  }
  
  if((temp.board[a.x+direction[DIR_X][a.dir]+1][a.y+direction[DIR_Y][a.dir]] == blue_opp)||(temp.board[a.x+direction[DIR_X][a.dir]+1][a.y+direction[DIR_Y][a.dir]] == red_opp)){
    if(temp.board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]] == blue_cur) reward -= 2;
  }
  if((temp.board[a.x+direction[DIR_X][a.dir]-1][a.y+direction[DIR_Y][a.dir]] == blue_opp)||(temp.board[a.x+direction[DIR_X][a.dir]-1][a.y+direction[DIR_Y][a.dir]] == red_opp)){
    if(temp.board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]] == blue_cur) reward -= 2;
  }
  if((temp.board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]+1] == blue_opp)||(temp.board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]+1] == red_opp)){
    if(temp.board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]] == blue_cur) reward -= 2;
  }
  if((temp.board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]-1] == blue_opp)||(temp.board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]-1] == red_opp)){
    if(temp.board[a.x+direction[DIR_X][a.dir]][a.y+direction[DIR_Y][a.dir]] == blue_cur) reward -= 2;
  }
  
  r = judge(s,a,player_cur);
  if(r==WIN) reward += 500;
  if(r==LOSE) reward -= 500;

  return reward;

  }

void strategy_random(struct STATE *s, struct ACTION *a, int player_cur){
  int flag;
  struct ACTION temp;

  do{
    temp.x = rand()%BDW;
    temp.y = rand()%BDH;
    temp.dir = rand()%4;
    flag = check( s, temp, player_cur);
  }while(flag == FALSE);
  printf("flag = %d\nTRUE:%d, FALSE:%d\n",flag,TRUE,FALSE);
  a->x = temp.x;
  a->y = temp.y;
  a->dir = temp.dir;

  return;
}

void strategy_grid_re(struct STATE *s, struct ACTION *a, int player_cur){
  int flag;
  int red_opp, blue_opp, red_cur, blue_cur;
  int player_opp;
  int i, j;
  int dice;
  int action = EXPLORATION;
  int loop = CONTINUE;
  struct ACTION temp;
  struct STATE test;

  player_opp = 1 - player_cur;
  red_opp = player_opp*2+RED*1;
  blue_opp = player_opp*2+BLUE*1;
  red_cur = player_cur*2+RED*1;
  blue_cur = player_cur*2+BLUE*1;

  for(i=0;i<BDW;i++){
    for(j=0;j<BDH;j++){
      test.board[i][j] = s->board[i][j];
    }
  }

  do{
      for(i=0;i<BDW;i++){
	for(j=0;j<BDH;j++){
	  if(s->board[i][j] == EMPTY) continue;
	  else if(s->board[i][j] == red_opp) continue;
	  else if(s->board[i][j] == blue_opp) continue;
	  else{
	    if((i != BDW-1)&&(loop == CONTINUE)){
	      if(s->ghost_num[player_opp][RED] == 1){
		if(s->board[i+1][j] == blue_opp){
		  temp.x = i;
		  temp.y = j;
		  temp.dir = EAST;
		  loop = BREAK;
		}
	      }else{
		if((s->board[i+1][j] == red_opp)||(s->board[i+1][j] == blue_opp)){
		  temp.x = i;
		  temp.y = j;
		  temp.dir = EAST;
		  loop = BREAK;
		}
	      }
	    }
	    if((i != 0)&&(loop == CONTINUE)){
	      if(s->ghost_num[player_opp][RED] == 1){
		if(s->board[i-1][j] == blue_opp){
		  temp.x = i;
		  temp.y = j;
		  temp.dir = WEST;
		  loop = BREAK;
		}
	      }else{
		if((s->board[i-1][j] == red_opp)||(s->board[i-1][j] == blue_opp)){
		  temp.x = i;
		  temp.y = j;
		  temp.dir = WEST;
		  loop = BREAK;
		}
	      }
	    }
	    if((j != BDH-1)&&(loop == CONTINUE)){
	      if(s->ghost_num[player_opp][RED] == 1){
		if(s->board[i][j+1] == blue_opp){
		  temp.x = i;
		  temp.y = j;
		  temp.dir = SOUTH;
		  loop = BREAK;
		}
	      }else{
		if((s->board[i][j+1] == red_opp)||(s->board[i][j+1] == blue_opp)){
		  temp.x = i;
		  temp.y = j;
		  temp.dir = SOUTH;
		  loop = BREAK;
		}
	      }
	    }
	    if((j != 0)&&(loop == CONTINUE)){
	      if(s->ghost_num[player_opp][RED] == 1){
		if(s->board[i][j-1] == blue_opp){
		  temp.x = i;
		  temp.y = j;
		  temp.dir = NORTH;
		  loop = BREAK;
		}
	      }else{
		if((s->board[i][j-1] == red_opp)||(s->board[i][j-1] == blue_opp)){
		  temp.x = i;
		  temp.y = j;
		  temp.dir = NORTH;
		  loop = BREAK;
		}
	      }
	    }
	    if(loop == CONTINUE) strategy_escape(s, &temp, player_cur);
	  }
	  if(loop == BREAK) break;
	}
	if(loop == BREAK) break;
      }
    
    flag = check( s, temp, player_cur);

  }while(flag == FALSE);
  a->x = temp.x;
  a->y = temp.y;
  a->dir = temp.dir;
  return;
}


void strategy_escape(struct STATE *s, struct ACTION *a, int player_cur){
  int min_dis_x, min_dis_y;
  int blue_cur;
  int flag;
  int i, j;
  int try = 0;
  struct ACTION temp;
  struct STATE test;
  int search = EMPTY;
  int dice;

  blue_cur = player_cur*2+BLUE*1;

  
  do{
    try++;
    do{
      temp.x = rand()%BDW;
      temp.y = rand()%BDH;
    }while(s->board[temp.x][temp.y] != blue_cur);
    dice=rand()%2;
    if(player_cur == PLAYER0){
      if(dice == 1){
	if(2 < temp.x) temp.dir = EAST;
	else temp.dir = WEST;
      }
      else temp.dir = NORTH;
    }
    else{
      if(dice == 1){
	if(2 < temp.x) temp.dir = EAST;
	else temp.dir = WEST;
      }
      else temp.dir = SOUTH;
    }
    if(try > BDW*BDH) strategy_random(s, &temp, player_cur);
    flag = check( s, temp, player_cur);
    //printf("flag_escape = %d\n",flag);
  }while(flag == FALSE);
  a->x = temp.x;
  a->y = temp.y;
  a->dir = temp.dir;
  return;

}

void strategy_red_foward(struct STATE *s, struct ACTION *a, int player_cur){
  int min_dis_x, min_dis_y;
  int red_cur;
  int flag;
  int i, j;
  int try = 0;
  struct ACTION temp;
  int search = EMPTY;
  int dice;

  red_cur = player_cur*2+RED*1;

  do{
    try++;
    do{
      temp.x = rand()%BDW;
      temp.y = rand()%BDH;
    }while(s->board[temp.x][temp.y] != red_cur);
    dice=rand()%3;
    if(player_cur == PLAYER0){
      if(dice == 1){
	if(2 < temp.x) temp.dir = EAST;
	else temp.dir = WEST;
      }
      else temp.dir = NORTH;
    }
    else{
      if(dice == 1){
	if(2 < temp.x) temp.dir = EAST;
	else temp.dir = WEST;
      }
      else temp.dir = SOUTH;
    }
    if(try > BDW*BDH) strategy_random(s, &temp, player_cur);
    flag = check( s, temp, player_cur);

  }while(flag == FALSE);
  a->x = temp.x;
  a->y = temp.y;
  a->dir = temp.dir;
  return;

}

void strategy_blue_back(struct STATE *s, struct ACTION *a, int player_cur){
  int min_dis_x, min_dis_y;
  int blue_cur;
  int flag;
  int i, j;
  int try = 0;
  struct ACTION temp;
  struct STATE test;
  int dice;

  blue_cur = player_cur*2+BLUE*1;

  for(i=0;i<BDW;i++){
    for(j=0;j<BDH;j++){
      test.board[i][j] = s->board[i][j];
    }
  }
  do{
    try++;
    do{
      temp.x = rand()%BDW;
      temp.y = rand()%BDH;
    }while(s->board[temp.x][temp.y] != blue_cur);
    dice=rand()%3;
    if(player_cur == PLAYER0){
      if(dice == 1){
	if(2 < temp.x) temp.dir = EAST;
	else temp.dir = WEST;
      }
      else temp.dir = SOUTH;
    }
    else{
      if(dice == 1){
	if(2 < temp.x) temp.dir = EAST;
	else temp.dir = WEST;
      }
      else temp.dir = NORTH;
    }
    if(try > BDW*BDH) strategy_random(s, &temp, player_cur);
    flag = check( s, temp, player_cur);
    //printf("flag_escape = %d\n",flag);
  }while(flag == FALSE);
  a->x = temp.x;
  a->y = temp.y;
  a->dir = temp.dir;
  return;
}

int com_play(struct STATE *s, int player_cur, int depth, struct ACTION *a){
  int flag;
  int i, j;
  int r = GAMECONTINUE;
  int temp_cur = player_cur;
  int temp_opp = 1 - temp_cur;
  int max_score = -1000;
  int score;
  int red_cur, blue_cur;
  int search = EMPTY;
  struct STATE temp;
  struct ACTION best;
  struct ACTION undo;
  int undo_board;
  int dice;
  int action = EXPLORATION;
 
  red_cur = temp_cur*2+RED*1;
  blue_cur = temp_cur*2+BLUE*1; 
  dice = rand()%100;
  
  if(dice<THRESHOLD) action = STRATEGY;

  for(i=0;i<BDW;i++){
    for(j=0;j<BDH;j++){
      temp.board[i][j] = s->board[i][j];
    }
  }
  for(i=0;i<2;i++){
    for(j=0;j<2;j++){  
      temp.ghost_num[i][j] = s->ghost_num[i][j];
    }
  }
  
  for(i=0;i<BDW;i++){
    for(j=0;j<BDH;j++){
      if(temp.board[i][j]==blue_cur) search = HIT;
    }
  }
  if(search != HIT)return -1000;
  search = EMPTY;
  for(i=0;i<BDW;i++){
    for(j=0;j<BDH;j++){
      if(temp.board[i][j]==red_cur) search = HIT;
    }
  }
  if(search != HIT)return 1000;

    if(player_cur == PLAYER0){
    if(temp.board[0][0] == blue_cur){
      best.x = 0;
      best.y = 0;
      best.dir = WEST;
    }
    if(temp.board[BDW-1][0] == blue_cur){
      best.x = BDW-1;
      best.y = 0;
      best.dir = EAST;
    }
  }else{
    if(temp.board[0][BDH-1] == blue_cur){
      best.x = 0;
      best.y = BDH-1;
      best.dir = WEST;
    }
    if(temp.board[BDW-1][BDH-1] == blue_cur){
      best.x = BDW-1;
      best.y = BDH-1;
      best.dir = EAST;
    }
  }
  flag = check( s, best, player_cur);
  if((flag != FALSE)&&(depth == START)){
    a->x =best.x;
    a->y =best.y;
    a->dir =best.dir;
    return 1000;
  }


  for(i=0;i<10;i++){
    do{
      if(temp.ghost_num[player_cur][BLUE] != 1){
	if(action == EXPLORATION)strategy_random(&temp,&best,player_cur);
	if(action == STRATEGY)strategy_grid_re(&temp,&best,player_cur);
      }else{
	dice = rand()%2;
	if(dice == 0)strategy_grid_re(&temp,&best,player_cur);
	else{
	  dice = rand()%2;
	  if(dice == 0)strategy_red_foward(&temp,&best,player_cur);
	  else strategy_blue_back(&temp,&best,player_cur);
	}
      }
      flag = check( &temp, best, temp_cur);
      }while(flag == FALSE);
    undo.x = best.x + direction[DIR_X][best.dir];
    undo.y = best.y + direction[DIR_Y][best.dir];
    undo.dir = anti_dir[best.dir];
    undo_board = temp.board[undo.x][undo.y];
    score = reward( &temp, best, temp_cur);

    if(depth == 0) return score;

    apply_action( &temp, best, temp_cur);
    r = judge(&temp,best,temp_cur);

    if(r == WIN){
      if(depth == START){
	a->x = best.x;
	a->y = best.y;
	a->dir = best.dir;
      }
	return 1000;
    }
    //if(r == LOSE)if (depth != START)return -1000;

    if(depth != 0) score = -com_play( &temp, temp_opp, depth-1, a);

    if(max_score<score){
      max_score = score;
      if(depth == START){
	a->x = best.x;
	a->y = best.y;
	a->dir = best.dir;

	if(player_cur==PLAYER0){
	  if(s->board[0][0] == blue_cur){
	    a->x = 0;
	    a->y = 0;
	    a->dir = NORTH;
	  }	
	  if(s->board[BDW-1][0] == blue_cur){
	    a->x = BDW-1;
	    a->y = 0;
	    a->dir = NORTH;
	  }
	}
	else{
	  if(s->board[0][BDH-1] == blue_cur){
	    a->x = 0;
	    a->y = BDH-1;
	    a->dir = SOUTH;
	  }
	  if(s->board[BDH-1][BDH-1] == blue_cur){	
	    a->x = BDH-1;
	    a->y = BDH-1;
	    a->dir = SOUTH;
	  }
	}  
      }
    }
    apply_action( &temp, undo, temp_cur);
    if(0 <= undo.x && undo.x < BDW && 0 <= undo.y && undo.y < BDH)
      temp.board[undo.x][undo.y] = undo_board;
  }

  return max_score;

}

int judge(struct STATE *s, struct ACTION a, int player_cur){

  int player_opp = 1 - player_cur;

  if(s->ghost_num[player_opp][BLUE]==0)return WIN;
  if(s->ghost_num[player_cur][RED]==0)return WIN;
  if(s->ghost_num[player_cur][BLUE]==0)return LOSE;
  if(s->ghost_num[player_opp][RED]==0)return LOSE;
  switch(a.dir){
  case NORTH:
    if(a.y-1<0)	if((a.x == 0)||(a.x == BDW-1)) return WIN;
    break;
  case EAST:
    if(a.x+1>BDW-1){
      if(a.y == 0) return WIN;
      if(a.y == BDH-1) return WIN;
    }
    break;
  case SOUTH:
    if(a.y+1>BDH-1) if((a.x == 0)||(a.x == BDW-1)) return WIN;
    break;
  case WEST:
    if(a.x-1<0){
      if(a.y == 0) return WIN;
      if(a.y == BDH-1) return WIN;
    }
    break;
  default: break;
  }

  return GAMECONTINUE;

}


int main(int argc, char **argv) {
  SOCKET gsock=INVALID_SOCKET;
  char *hostaddr=NULL,*hostport=NULL;
  int waittime;
  int player_com;

  int i, j, k=0;
  int r = GAMECONTINUE;
  int red_cur, blue_cur, red_opp, blue_opp, player_opp;
  int search = EMPTY;
  //int match=0;
  char rep[10];
  char ghost[10];
  char mov[10];
  char action[10];
  char board_char[BDSIZ];
  struct STATE trans;
  int red_count=0, blue_count=0;

  // process arguments
  printf("usage: %s [hostaddr] [hostport] [waittime]\n", argv[0]);
  if (argc<3) {
    fprintf(stderr,"Please give hostaddr and hostport\n");
    exit(1);
  }
  hostaddr = argv[1];
  hostport = argv[2];
  printf("host = %s:%s\n",hostaddr,hostport);
  waittime=(argc>=3)?atoi(argv[3]):0;
  if (waittime<0) waittime=0;
  printf("wait = %dsec\n",waittime);

  //player_com = (argv[2][0]=='0')?PLAYER0:PLAYER1;
  player_com = PLAYER0;

  // connect to server
  gsock=ConnectGeisterHost(hostaddr,hostport);
  if (gsock==INVALID_SOCKET) exit(1);

  Sleep(1000);

  // initialize board  (Sonoda-Axis player0=south)
  board_init(&trans);
  ghost_set_com( &trans, player_com);

  fprintf(stderr,"start the game\n");

  // send ghostinfo(red or blue) to host
  SendGhostInfo(gsock,&trans,player_com);

  // inialize estimation history
  estimation_init();

  fprintf(stderr,"enter the main loop\n");

  sleep(waittime);

  // main game turns
  while(1){
    struct STATE estimate;
    struct ACTION action;

    // receive the board state
    fprintf(stderr,"receiving the board state\n");
    r = RecvBoardState(gsock,&trans,player_com);
    if (r!=GAMECONTINUE) break;

    // execute computer player
    fprintf(stderr,"estimating the opponent's units\n");
    estimation(&trans,player_com,&estimate);
    fprintf(stderr,"playng the game\n");
    com_play(&estimate,player_com,START,&action);
    //strategy_random(&trans,&action,player_com);
    printf("X:%d, Y:%d, DIR:%d\nN:%d, E:%d, S:%d, W:%d\n",action.x,action.y,action.dir,NORTH,EAST,SOUTH,WEST);

    // send the action
    fprintf(stderr,"sending the action\n");
    SendAction(gsock,&trans,player_com,&action);

    // update the state
    fprintf(stderr,"updating the play\n");
    estimation_update(&estimate);
    fprintf(stderr,"applying the action\n");
    apply_action(&trans,action,player_com);

    sleep(waittime);
  }

  CloseGeisterHost(gsock);
  
  return 0;
}
